uniform   vec2 u_TextureSize;
uniform   vec2 u_OutputSize;
uniform   mat4 u_MVPMatrix;
attribute vec4 a_Position;
attribute vec2 a_TexCoordinate;
varying   vec2 v_TexCoordinate;

varying vec4 t1;
varying vec4 t2;
varying vec4 t3;
varying vec4 t4;
varying vec4 t5;
varying vec4 t6;
varying vec4 t7;

void main()
{
    float dx = 1.0 / u_OutputSize.x;
    float dy = 1.0 / u_OutputSize.y;

    vec4 a_vertex_coordinate = u_MVPMatrix * a_Position;

    gl_Position = vec4(a_vertex_coordinate.xy, 0.0, 1.0);
    v_TexCoordinate = a_TexCoordinate.xy;

    t1 = v_TexCoordinate.xxxy + vec4( -dx, 0.0, dx,-2.0*dy);
    t2 = v_TexCoordinate.xxxy + vec4( -dx, 0.0, dx, -dy);
    t3 = v_TexCoordinate.xxxy + vec4( -dx, 0.0, dx, 0.0);
    t4 = v_TexCoordinate.xxxy + vec4( -dx, 0.0, dx, dy);
    t5 = v_TexCoordinate.xxxy + vec4( -dx, 0.0, dx, 2.0*dy);
    t6 = v_TexCoordinate.xyyy + vec4(-2.0*dx,-dy, 0.0, dy);
    t7 = v_TexCoordinate.xyyy + vec4( 2.0*dx,-dy, 0.0, dy);
}